# shinobi-tensorflow.js


This is a [Shinobi](https://gitlab.com/Shinobi-Systems/Shinobi) plugin, 
based on the preinstalled Tensorflow plugin. It has being expanded to 
post an image and associated prediction matrices for objects detected 
by Tensorflow. These are posted to a message queue for further 
processing.


## Architecture

The plugin forks a NodeJS process (notify.js) that receives object 
detections from the parent process (shinobi-tensorflow.js) over a
NodeJS IPC (Inter Process Channel). These are forwarded to listening
external systems, notified via a publish subscribe mechanism using
an MQTT message queue broker.

![PluginArchitecture](https://i.ibb.co/NC32hZn/mqtt-tensorflow-plugin-architecture.png)

An object detection is dispatched to the MQTT broker when the following 
conditions are met:

- Confidence is >= minimum confidence config parameter, _minConfidence_.
- The predicted object class matches at least one of those included 
  in a configuration parameter, _objectClasses_.
- Timeout period is not running. A timeout period is triggered after
  a message has been despatched onto the queue. If the timer is
  running then object detections are skipped, i.e. not posted on
  queue.

Messages containing object detections are published onto the MQTT broker
in the following JSON format:

``` json
{
  "group": "myGroup",
  "monitorId": "myMonitorId",
  "time": "2020-04-24T13:49:16+00:00",
  "plug": "TensorFlow-WithFiltering-And-MQTT",
  "details": {
    "plug": "TensorFlow-WithFiltering-And-MQTT",
    "name": "Tensorflow",
    "reason": "object",
    "matrices": [{
      "x": "2.313079833984375",
      "y": "1.0182666778564453",
      "width": "373.25050354003906",
      "height": "476.9341278076172",
      "tag": "person",
      "confidence": "0.7375929355621338"
    }],
    "img": "base64",
    "imgHeight": "64",
    "imgWidth": "48",
    "time": "2020-04-24T13:49:16+00:00"
  }
}
```

Each detection is published to MQTT with the following topic format to allow 
notifications to be sent for each camera in
[Shinobi](https://gitlab.com/Shinobi-Systems/Shinobi):

``` js
`shinobi/${group}/${monitor}/trigger`
```


## Development Technologies

The following technologies are used:

- **[Docker](https://www.docker.com/)** and [Docker-Compose](https://docs.docker.com/compose/): For providing a configurable and 
quick way to run an MQTT broker for end-to-end testing.
- **[Jest](https://jestjs.io/)**: For writing and running tests.
- **[MQTT.js](https://github.com/mqttjs)**: Message queue for publishing and subscribing object detections.
- **[NodeJS](https://nodejs.org/en/)**: For implementing the [Shinobi](https://gitlab.com/Shinobi-Systems/Shinobi) plugin.
- **[Pino](https://github.com/pinojs/pino)**: Fast JSON logging framework.


## Installation

Firstly, clone the Shinobi fork as follows:

```
git clone https://gitlab.com/cctv_web_cam/shinobi/cambase.git
```

Follow the instructions for installation of Shinobi using the resources detailed
[here](https://gitlab.com/Shinobi-Systems/Shinobi).

1. Go to the plugin installation directory. ```cd <my shinobi>/plugins/objectdetection```
2. Copy the sample config file. ```cp config.sample.json config.json```
3. Run the installation script _INSTALL.sh_. ```./INSTALL.sh```

The plugin installer script will prompt for installation of the 
tensorflow gpu library to offload detection processing to the graphics 
card. Type _y_ to install this feature.

The plugin also prompts if the CPU is Intel Quad Core 2. This will install
tensorflow nodejs precompiled library compatible with CPU Intel Quad Core 2
processors. Type _y_ to install this feature. 

4. Start the plugin ```sudo pm2 start shinobi-tensorflow.js```

If the plugin has been successfully started then _TensorFlow-WithFiltering-And-MQTT_ 
should be revealed in the header of the Object Detection configuration section of the
Shinobi web interface for the camera monitor.


## Configuration

A sample configuration file is listed below:

```
{
  "host":"localhost",
  "hostPort":8082,
  "key":"key generated by installer script INSTALLER.sh",
  "mode":"client",
  "mqtt": {
    "mqttsUrl":"mqtts://user:pass@localhost:8883",
    "cafile":"full path to CA file",
    "rejectUnauthorised": "true"
  },
  "objectDetection": {
    "minConfidence":0.70,
    "objectClasses":"person",
    "timeoutPeriod":1200000
  },
  "plug":"TensorFlow-WithFiltering-And-MQTT",
  "port":8080,
  "tfjsBuild":"cpu",
  "type":"detector"
}
```

The plugin is configured by the _mqtt_ and _objectDetection_ sections.


### Message Queue Configuration

[MQTT.js](https://github.com/mqttjs) is used as the message broker. This can 
be configured using the following options:


| Option              | Description                                   | Example                           |
|---------------------|-----------------------------------------------|-----------------------------------|
| mqttsUrl            | Url for mqtts including user credentials      | mqtts://user:pass@localhost:8883  |
| cafile              | Path to certificate authority file            | /some/path/to/cafile              |
| rejectUnauthorised  | Should untrusted CA certificates be rejected? | true                              | 



### Object Detection Configuration


| Option              | Description                                   | Example                           |
|---------------------|-----------------------------------------------|-----------------------------------|
| minConfidence       | decimal number between 0 and 1 to describe    | 0.70                              |
|                     | minimum confidence threshold for a message to |                                   |
|---------------------|-----------------------------------------------|-----------------------------------|
| objectClasses       | Comma separated list of objects to trigger    | person, cat                       |
|                     | messages for                                  |                                   |
|---------------------|-----------------------------------------------|-----------------------------------|
| timeoutPeriod       | Timeout, in seconds, that runs after a        | 120000                            |
|                     | after a detection has been sent to message    |                                   |
|                     | queue. If a detection is received and the     |                                   |
|                     | timer is running then it is not sent onto the |                                   |
|                     | queue. This was done so that if a recording   |                                   |
|                     | is triggered by motion then a obhect image    |                                   |
|                     | image can be sent every _n_ seconds           |                                   |
|---------------------|-----------------------------------------------|-----------------------------------|


## Running Tests

[Jest](https://jestjs.io/) has been used to write and run tests. The following scripts can be run from
within the _plugins/objectdetection_ folder:

``` bash
# run unit tests
yarn run test

# run end to end tests
yarn run test:e2e
```

The end-to-end tests require docker and docker-compose to be installed on the developers machine. 
Docker is used to quickly configure and start an MQTT broker on the developer's environment.
This requires developers setup server certificates in ./tests/docker/certs folder.
Further details on configuring the docker MQTT broker can be found in tests/docker/README.md.
